<obituary-form-template-picker>
  <style>
    .obituary-template .card {
      border: 1px solid rgba(0, 0, 0, 0.125);
    }

    .obituary-template:hover .card {
      box-shadow: 0 0.5rem 1rem rgba(0, 0, 0, 0.3) !important;
    }

    .active {
      box-shadow: 0 0.5rem 1rem rgba(0, 0, 0, 0.3) !important;
      outline-style: outset;
    }

    .card {
      min-height: 300px;
    }

    button[disabled] {
      cursor: not-allowed;
    }

    /** Obituary Card Group Css Start */
    .obituary-card-group {
      justify-content: space-evenly;
    }

    .obituary-card-group .card {
      border: 1px solid rgba(0, 0, 0, 0.125) !important;
    }

    .obituary-card-sm {
      border-radius: 0 !important;
      text-align: center;
      flex-grow: 0.245 !important;
    }

    .obituary-card-md {
      border-radius: 0 !important;
      text-align: center;
      flex-grow: 0.495 !important;
    }

    .obituary-card-lg {
      border-radius: 0 !important;
      text-align: center;
      flex-grow: 1 !important;
    }

    .obituary-card-group .card.obituary-card-featured {
      border: 4px solid black !important;
    }

    .obituary-card-group .card.obituary-card-featured .card-title {
      font-weight: 700;
    }

    .obituary-card-group .card.obituary-card-featured .card-subtitle {
      font-weight: 700;
    }

    .obituary-card-group .card:hover {
      box-shadow: 0 0.5rem 1rem rgba(0, 0, 0, 0.3) !important;
      cursor: pointer;
    }

    @media (max-width: 991.98px) {
      .obituary-card-group {
        flex-direction: column;
      }
    }

    /** Obituary Card Group Css End */
  </style>

  <div class="obituary-form-template-picker">
    <div class="row mb-4">
      <div class="col-lg-12">
        <div class="form-group">
          <div class="custom-control custom-switch d-lg-inline">
            <input ref="is_featured" id="is_featured" name="is_featured" type="checkbox" class="custom-control-input">
            <label for="is_featured" class="custom-control-label font-weight-bold">{ config.isFeaturedSwitch.label }</label>
          </div>
          <div class="d-lg-inline">
            { config.isFeaturedSwitch.description }
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-lg-12">
        <div class="obituary-card-group card-group mb-2">
          <obituary-card-lg obituary={ templateObituary } isFormView={ true } displayType={ displayType }></obituary-card-lg>
        </div>
        <div class="obituary-card-group card-group">
          <obituary-card-md obituary={ templateObituary } isFormView={ true } displayType={ displayType }></obituary-card-md>
          <obituary-card-sm obituary={ templateObituary } isFormView={ true } displayType={ displayType }></obituary-card-sm>
        </div>
      </div>
    </div>
  </div>

  <script>
    let self = this;

    this.TEMPLATE_SMALL = 1;
    this.TEMPLATE_MEDIUM = 2;
    this.TEMPLATE_LARGE = 3;

    this.selectedTemplate = this.parent.obituary.template_id || undefined;
    this.templateObituary = this.opts.templateconfig.config;
    this.config = this.opts.templateconfig.config;
    this.isFeatured = this.parent.obituary.is_featured || undefined;

    this.displayType = this.parent.obituary.displayType || undefined;

    this.on('mount', function () {
      let obituaryCardLgLink = $(this.root).find('.obituary-card-lg .stretched-link');
      let obituaryCardMdLink = $(this.root).find('.obituary-card-md .stretched-link');
      let obituaryCardSmLink = $(this.root).find('.obituary-card-sm .stretched-link');

      let obituaryCardLg = $(this.root).find('.obituary-card-lg');
      let obituaryCardMd = $(this.root).find('.obituary-card-md');
      let obituaryCardSm = $(this.root).find('.obituary-card-sm');

      $(obituaryCardLgLink).click(function (_e) {
        self.setTemplate(self.TEMPLATE_LARGE);

        $(obituaryCardLg).addClass('active');

        $(obituaryCardMd).removeClass('active');
        $(obituaryCardSm).removeClass('active');
      });

      $(obituaryCardMdLink).click(function (_e) {
        self.setTemplate(self.TEMPLATE_MEDIUM);

        $(obituaryCardMd).addClass('active');

        $(obituaryCardSm).removeClass('active');
        $(obituaryCardLg).removeClass('active');
      });

      $(obituaryCardSmLink).click(function (_e) {
        self.setTemplate(self.TEMPLATE_SMALL);

        $(obituaryCardSm).addClass('active');

        $(obituaryCardMd).removeClass('active');
        $(obituaryCardLg).removeClass('active');
      });

      if (self.selectedTemplate) {
        switch (self.selectedTemplate) {
          case self.TEMPLATE_SMALL:
            $(obituaryCardSmLink).click();
            break;
          case self.TEMPLATE_MEDIUM:
            $(obituaryCardMdLink).click();
            break;
          case self.TEMPLATE_LARGE:
            $(obituaryCardLgLink).click();
            break;
        }
      }

      if (self.isFeatured) {
        $(self.refs.is_featured).click();

        self.obituaryCardsFeatured();
      }

      $(self.refs.is_featured).change(function(e) {
        let isFeaturedBool = e.target.checked;

        self.parent.obituary.is_featured = isFeaturedBool ? 1 : 0;
        self.parent.calculatePrice();
        self.parent.update();

        isFeaturedBool ? self.obituaryCardsFeatured() : self.obituaryCardsNotFeatured();
      });
    });

    obituaryCardsFeatured() {
      let obituaryCardLg = $(this.root).find('.obituary-card-lg');
      let obituaryCardMd = $(this.root).find('.obituary-card-md');
      let obituaryCardSm = $(this.root).find('.obituary-card-sm');

      $(obituaryCardMd).addClass('obituary-card-featured');
      $(obituaryCardSm).addClass('obituary-card-featured');
      $(obituaryCardLg).addClass('obituary-card-featured');
    }

    obituaryCardsNotFeatured() {
      let obituaryCardLg = $(this.root).find('.obituary-card-lg');
      let obituaryCardMd = $(this.root).find('.obituary-card-md');
      let obituaryCardSm = $(this.root).find('.obituary-card-sm');

      $(obituaryCardMd).removeClass('obituary-card-featured');
      $(obituaryCardSm).removeClass('obituary-card-featured');
      $(obituaryCardLg).removeClass('obituary-card-featured');
    }

    setTemplate(templateId) {
      this.selectedTemplate = parseInt(templateId);
      this.update();

      this.parent.obituary.template_id = parseInt(templateId);
      this.parent.calculatePrice();
      this.parent.update();
    }

    getTemplateClasses(template) {
      return template === this.selectedTemplate ? 'card mb-4 active' : 'card mb-4';
    }

    isTemplateEmpty() {
      return this.selectedTemplate === undefined;
    }
  </script>
</obituary-form-template-picker>
